;***************************************************************************
; Hodiny V1.1    (c) ASIX s.r.o. 1995
; Peklad oven na pekladai:
;   MPASM 02.01 
;***************************************************************************
        list    F=inhx8m, p=16c55, r=hex        ; 
        __config        0ff9h                   ; pojistky
; frekvence vnjho osciltoru je 3.2768MHz => instrukn cyklus = 1.22s
; kdy to vynsobme 256 (rtcc) a 16 (peddli), dostaneme pesn 5ms
;***************************************************************************
; Zapojen pin
;   RA0 buzen anody tvrt slice zleva (DISP0)                  (out)
;   RA1 buzen anody tet  slice zleva (DISP1)                  (out)
;   RA2 buzen anody druh  slice zleva (DISP2)                  (out)
;   RA3 buzen anody prvn  slice zleva (DISP3)                  (out)
;   RB0 a RB7 jednotliv segmenty slic, pouv se v multiplexu (out)
;   RB0 spolen rove pro tlatka                               (out)
;   RB1 tlatko 1 - start / stop                                  (in)
;   RB2 tlatko 2 - pepnn zobrazovn                         (in)
;   RB3 tlatko 3 - nastaven hodin                               (in)
;   RB4 tlatko 4 - nastaven minut                               (in)
;   RC0 a RC7 nepouit port                                      (out)
;***************************************************************************
ind     equ     00h     ; registr f0
rtcc    equ     01h     ; 
pc      equ     02h     ; 
stat    equ     03h     ; 
fsr     equ     04h     ; 
porta   equ     05h     ; 
portb   equ     06h     ; 
portc   equ     07h     ; 

hod     equ     08h     ; registr na uloen hodin v BCD kdu
min     equ     09h     ; registr na uloen minut v BCD kdu
sec     equ     0ah     ; registr na uloen vtein v BCD kdu
                        ; mus bt za sebou v tomto poad

citac   equ     0bh     ; ta 1 vteiny
konec   equ     0ch     ; registr pro uloen konen hodnoty pi aktualizaci
stav1   equ     0dh     ; stav systmu
                        ; bit0: 0 tlatko nestisknuto (poten stav)
                        ;       1 tlatko uznno za stisknut a stle dreno
                        ; bit1: 0 hodiny b (poten stav)
                        ;       1 hodiny stoj
                        ; bit2: 0 zobrazujeme hodiny a minuty (poten stav)
                        ;       1 zobrazujeme minuty a vteiny
cit_m   equ     0eh     ; ta multiplexu, t 0,1,2,3,0,1,2,3,0,1,...
digit   equ     0fh     ; registr pro zobrazovanou slici
new     equ     10h     ; registr na uloen stavu tlatek - nov hodnoty
old     equ     11h     ; registr na uloen stavu tlatek - star hodnoty
cit_p   equ     12h     ; ta prodlevy

w       equ     00h     ; 
f       equ     01h     ; 
carry   equ     00h     ; bit 0 stavovho slova
dcarry  equ     01h     ; bit 1 stavovho slova
nula    equ     02h     ; bit 2 stavovho slova
push    equ     00h     ; bit 0 registru stav1
stop    equ     01h     ; bit 1 registru stav1
hm      equ     02h     ; bit 2 registru stav1
dp      equ     07h     ; bit 7 portu B (desetinn teka)

        org     00h             ; program zan v pamti od adresy 00h
;***************************************************************************
; Rutina kduje BCD slice na kd pro sedmisegmentov displej. Vstup i vs-
; tup se dje pes registr w, vstup je slice BCD, vstupem je pak obsah
; registru w, kter posln na port B rozsvt pslunou slici. Segment
; svt, je-li pslun bit portu B v nule.
tab1    addwf   pc, f           ; vbr slice
        retlw   b'11000000'     ; 0 - zobraz 0
        retlw   b'11111001'     ; 1 - zobraz 1
        retlw   b'10100100'     ; 2 - zobraz 2
        retlw   b'10110000'     ; 3 - zobraz 3
        retlw   b'10011001'     ; 4 - zobraz 4
        retlw   b'10010010'     ; 5 - zobraz 5
        retlw   b'10000010'     ; 6 - zobraz 6
        retlw   b'11111000'     ; 7 - zobraz 7
        retlw   b'10000000'     ; 8 - zobraz 8
        retlw   b'10010000'     ; 9 - zobraz 9
;***************************************************************************
; Rutina kduje podle cit_m jednu anodu, kter bude aktivn. Vstup i vstup
; je opt pes registr w, vstup se tentokrt posl na port A. Anoda je
; aktivovna, je-li pslun bit portu A v nule.
tab2    addwf   pc, f           ; vbr anody
        retlw   b'11110111'     ; cit_m=0 - aktivuje anodu 3
        retlw   b'11111011'     ; cit_m=1 - aktivuje anodu 2
        retlw   b'11111101'     ; cit_m=2 - aktivuje anodu 1
        retlw   b'11111110'     ; cit_m=3 - aktivuje anodu 0
;***************************************************************************
; Rutina rozsvt na 5ms jednu slici ze ty monch. Vbr slice se
; provd jednak na zklad bitu hm registru stav1 a jednak na zklad
; hodnoty tae multiplexu cit_m.
zobraz  movlw   0ffh
        movwf   porta           ; odpojen anod displeje
        movlw   hod
        movwf   fsr             ; adresa registru hod do fsr
        btfsc   stav1, hm       ; zobrazujeme hod a min? (bit=0?)
        incf    fsr, f          ; ne  => v fsr je adresa min
                                ; ano => nic se nedje
        bcf     stat, carry     ; nulovn carry pro rotaci
        rrf     cit_m, w        ; ta multiplexu dlen dvma je ve w
                                ; v carry je 1, byl-li cit_m lich,
                                ;            0, byl-li cit_m sud
        iorlw   00h             ; nastavuje bit nula stavovho slova
                                ; nutn - instrukce rrf to nedl
        btfss   stat, nula      ; pvodn hodnota cit_m = 0 nebo 1? (Z=1?)
        incf    fsr, f          ; ne  => fsr ukazuje na nsledujc registr:
                                ;        sec, jsme-li v reimu min, sec
                                ;        min, jsme-li v reimu hod, min
                                ; ano => nic se nedje
        movf    ind, w          ; vybran registr do w
        movwf   digit           ; a w do digit
        btfss   stat, carry     ; cit_m byl lich? (C=1?)
        swapf   digit, f        ; ne  => prohodme tveice
                                ; ano => beze zmny
        movlw   b'00001111'
        andwf   digit, w        ; zamaskovn, vsledkem je jedna BCD slice
        call    tab1            ; pekdovn BCD slice na segmenty
        movwf   portb           ; kdy segment na port B
        movf    cit_m, w        ; cit_m do w
        call    tab2            ; podle cit_m dekdujeme jednu anodu
        movwf   porta           ; aktivace pslun anody
        bcf     stat, carry     ; nulovn carry pro rotaci
        rrf     sec, w          ; vteiny dlen dvma do w
        btfsc   stat, carry     ; zobrazuji sudou vteinu? (C=0?)
        goto    zobr_a          ; ne  => dvojteka zhasnuta
                                ; ano => rozsvtme jednu z diod DP2 nebo DP1,
                                ;        vzhledem k multiplexu pak vidme
                                ;        vodorovnou "dvojteku"
        movf    cit_m, w
        xorlw   01h
        btfsc   stat, nula      ; cit_m = 1? (Z=1?)
        bcf     portb, dp       ; ano => rozsvtm diodu DP2
                                ; ne  => nic se nedje
zobr_a  incf    cit_m, f        ; inkrementujeme cit_m
        movlw   b'00000011'
        andwf   cit_m, f        ; zamaskovn, cit_m te t jen do 3
        retlw   00h             ; konec
;***************************************************************************
; Rutina zajist oeten zkmit pi ten tlatek a zrove zajist na-
; staven pslunch bit registru stav1, ktermi se d stav systmu.
; Rutina te tlatka kadch 20ms (vyuvn registr cit_m), a je-li tla-
; tko dreno alespo dvakrt za sebou, uzn se stisknut za platn.
tlacit  movf    cit_m, w
        btfss   stat, nula      ; cit_m = 0? (Z=1?)
        retlw   00h             ; ne  => konec
        movlw   b'11111111'     ; ano => ten stavu tlatek
        movwf   porta           ; odpojen anod displeje
        movlw   b'11111111'     ; 
        tris    portb           ; RB0..7 vstupy
        movlw   .56
        movwf   cit_p           ; ta prodlevy = 56
tlac_a  decfsz  cit_p, f        ; prodleva na ustlen stavu na sbrnici
        goto    tlac_a          ; asi 200s
        movf    portb, w        ; ten portu B (stav tlatek)
                                ; tlatko stisknuto => na pinu je 0
        xorlw   b'11111111'     ; negace stavu tlatek
        andlw   b'00011110'     ; zamaskovn nepotebnch bit
                                ; tlatko stisknuto => bit registru je 1
        movwf   new             ; pepis stavu tlatek do registru new
        clrf    portb           ; nulovn portu B ped pepnutm smru
        movlw   00h
        tris    portb           ; port B opt jako vstup
        btfss   stav1, push     ; tlatko stle dreno? (bit push=1?)
        goto    tlac_b          ; ne  => dal zpracovn
                                ; ano => test, zda-li bylo putno
        clrf    old             ; nulovn old
        movf    new, w
        btfsc   stat, nula      ; new = 0? (Z=1?)
        bcf     stav1, push     ; ano => tlatko putno, bit shozen, konec
        retlw   00h             ; ne  => pouze konec

tlac_b  movf    old, w          ; star stav tlatek do w
        andwf   new, w          ; ve w je new and old
        btfss   stat, nula      ; new and old = 0? (Z=1?)
        goto    tlac_c          ; ne  => tlatko stisknuto
        movf    new, w          ; ano => pepis novho stavu do starho
        movwf   old
        retlw   00h             ; a konec

tlac_c  bsf     stav1, push     ; tlatko dreno, nastaven bitu
        btfss   new, 1          ; stisknuto tlatko start/stop? (bit1=1?)
        goto    tlac_d          ; ne  => dal testovn
        movlw   b'00000010'     ; ano => negace bitu stop, ostatn beze zmn
        xorwf   stav1, f
        btfsc   stav1, stop     ; hodiny stoj? (bit stop=1?)
        clrf    sec             ; ano => nulovn vtein a konec
        retlw   00h             ; ne  => pouze konec

tlac_d  btfss   new, 2          ; stisknuto tlatko pepnn? (bit2=1?)
        goto    tlac_e          ; ne  => dal testovn
        movlw   b'00000100'     ; ano => negace bitu hm, ostatn beze zmn
        xorwf   stav1, f
        retlw   00h             ; a konec

tlac_e  btfss   new, 3          ; stisknuto tlatko nastaven hod? (bit3=1?)
        goto    tlac_f          ; ne  => stisknuto tlatko nastaven min
        movlw   hod             ; ano => inkrementujeme hodiny
        movwf   fsr
        movlw   24h
        movwf   konec           ; vbr hodin
        call    aktual          ; aktualizace hodin
        retlw   00h             ; a konec

tlac_f  movlw   min             ; inkrementujeme minuty
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr minut
        call    aktual          ; aktualizace minut
        retlw   00h             ; a konec
;***************************************************************************
; Aktualizan rutina, vstup je adresa registru, jen se m aktualizovat
; (uloen ped volnm do fsr) a hodnota pro peteen (registr konec).
; Rutina pite jedniku s BCD korekc k registru, na kter ukazuje fsr.
; Jestlie se tento registr po piten jedniky rovn registru konec,
; rutina tento registr nuluje a nastavuje Z=1.
aktual  movlw   .7
        addwf   ind, f          ; pite do ind 1 s BCD korekc
        btfsc   stat, dcarry
        goto    akt_a
        movlw   .6
        subwf   ind, f
akt_a   movf    konec, w
        xorwf   ind, w
        btfsc   stat, nula      ; ind = konec? (Z=1?)
        clrf    ind             ; ano => nulovan ind
        retlw   00h             ; ne  => konec
;***************************************************************************
; Rutina zajist ekn 5ms (ne od okamiku voln rutiny, ale od poslednho
; peteen rtcc).
_5ms    comf    rtcc, w
        btfss   stat, nula      ; rtcc = 0ffh? (Z=1?)
        goto    _5ms            ; ne  => ekme
                                ; ano => testujeme peteen
_5ms_a  btfsc   rtcc, 0         ; rtcc petekl? (bit0=0?)
        goto    _5ms_a          ; ne  => ekme na peteen
        retlw   00h             ; ano => konec
;***************************************************************************
; Inicializan rutina, nastav porty a stav systmu, vynuluje hodiny,
; minuty, vteiny a pejde do reimu relnho asu se zobrazovnm hodin
; a minut.
init    movlw   0ffh            ; nastaven portu A
        movwf   porta           ; budie zaveny => nic nesvt
        clrf    portb           ; nulovn portu B
        clrf    portc           ; nulovn portu C
        movlw   00h
        tris    porta           ; port A jako vstupn
        tris    portb           ; port B jako vstupn
        tris    portc           ; port C jako vstupn
        movlw   b'00000011'
        option                  ; rtcc buzen intern, peddli 1:16
        clrf    stav1           ; poten nastaven stavu systmu
        clrf    cit_m           ; nulovn tae multiplexu
        clrf    hod             ; nulovn hodin
        clrf    min             ; nulovn minut
        clrf    sec             ; nulovn vtein
        clrf    new             ; nulovn registru pro stav tlatek
        clrf    old             ; nulovn registru pro stav tlatek
        goto    real            ; konec, skok do reimu relnho asu
;***************************************************************************
real    movlw   .200
        movwf   citac           ; hlavn ta na 1s
real_a  decfsz  citac, f        ; uplynula 1s?
        goto    real_b          ; ne  => jdeme dle
        movlw   .200
        movwf   citac           ; ano => znovunastaven tae
        btfsc   stav1, stop     ; hodiny b? (bit stop=0?)
        goto    real_b          ; ne  => jdeme dle
        movlw   sec             ; ano => aktualizujeme as
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr vtein
        call    aktual          ; aktualizace vtein
        btfss   stat, nula      ; sec = 60? (Z=1?)
        goto    real_b          ; ne  => pokraujeme
        movlw   min             
        movwf   fsr             ; ano => vbr minut
        call    aktual          ; aktualizace minut
        btfss   stat, nula      ; min = 60? (Z=1?)
        goto    real_b          ; ne  => pokraujeme
        movlw   hod
        movwf   fsr
        movlw   24h
        movwf   konec           ; ano => vbr hodin
        call    aktual          ; aktualizace hodin
real_b  call    tlacit          ; voln rutiny na zpracovn tlatek
        call    zobraz          ; zobrazen asu
        call    _5ms            ; ekej 5ms
        goto    real_a          ; a pod dokola
;***************************************************************************


        org     1ffh            ; tady zan PIC po resetu
;***************************************************************************
	goto    init                    ; skok na zatek programu
;***************************************************************************
        end
